package com.persagy.apm.energyalarmstarter.alarmengine.redis;

import cn.hutool.json.JSONUtil;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

/**
 * redis工具类(因为要注册到spring boot，要注意名称不能重复)
 *
 * @author lixing
 * @version V1.0 2021/11/20 5:00 下午
 **/
@Service
public class RedisUtil4EngineStater {
    @Autowired
    RedisTemplate redisTemplate;

    /**
     * redis解锁
     *
     * @param key 要解锁的key
     * @author lixing
     * @version V1.0 2021/11/20 2:19 下午
     */
    @SneakyThrows
    public void unlock(String key) {
        redisTemplate.delete(key);
    }

    public <T> T get(String mapName, String key, Class<T> resultClazz) {
        Object obj = redisTemplate.opsForHash().get(mapName, key);
        if (obj == null) {
            return null;
        }
        return JSONUtil.toBean(obj.toString(), resultClazz);
    }

    public void put(String mapName, String key, String value) {
        redisTemplate.opsForHash().put(mapName, key, value);
    }

    public void delete(String mapName, String key) {
        redisTemplate.opsForHash().delete(mapName, key);
    }
}
